"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var node_fetch_1 = __importDefault(require("node-fetch"));
var events_1 = require("events");
var utils_1 = require("../utils");
var enums_1 = require("../enums");
var PacketHandler_1 = __importDefault(require("./PacketHandler"));
var TribullePacketHandler_1 = __importDefault(require("./TribullePacketHandler"));
var OldPacketHandler_1 = __importDefault(require("./OldPacketHandler"));
/**
 * Represents a client that connects to Transformice.
 *
 * @example
 * ```js
 * const { Client, enums } = require("transformice.js");
 *
 * const client = new Client("username", "password", {
 * 	language: enums.languages.en
 * });
 *
 * client.on("roomMessage", (message) => {
 * 	if (client.name === message.author.name) return;
 * 	client.sendRoomMessage(message.author.look);
 * });
 *
 * client.run("tfm_id", "token");
 * ```
 *
 * @noInheritDoc
 */
var Client = /** @class */ (function (_super) {
    __extends(Client, _super);
    function Client(name, password, options) {
        var _a;
        var _this = _super.call(this) || this;
        _this.autoReconnect = (_a = options === null || options === void 0 ? void 0 : options.autoReconnect) !== null && _a !== void 0 ? _a : true;
        _this.language = (options === null || options === void 0 ? void 0 : options.language) || enums_1.languages.en;
        _this.whoList = {};
        _this.channels = [];
        _this.loops = {};
        _this.tribulleId = 0;
        _this.name = name;
        _this.password = password;
        return _this;
    }
    Client.prototype.waitFor = function (eventName, timeoutOrCondition, conditionOrTimeout) {
        var _this = this;
        if (timeoutOrCondition === void 0) { timeoutOrCondition = 5000; }
        var timeout = 5000;
        var condition = undefined;
        if (typeof timeoutOrCondition === "number")
            timeout = timeoutOrCondition;
        else if (typeof timeoutOrCondition === "function")
            condition = timeoutOrCondition;
        if (typeof conditionOrTimeout === "number")
            timeout = conditionOrTimeout;
        else if (typeof conditionOrTimeout === "function")
            condition = conditionOrTimeout;
        return new Promise(function (resolve, reject) {
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            var listener = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                // eslint-disable-next-line @typescript-eslint/ban-ts-comment
                // @ts-ignore
                if (!condition)
                    resolve(args);
                else if (condition && condition.apply(void 0, __spread(args)))
                    resolve(args);
            };
            _this.once(eventName, listener);
            setTimeout(function () {
                _this.removeListener(eventName, listener);
                reject(new Error("Timed out"));
            }, timeout);
        });
    };
    /**
     * Handles the old packets and emits events.
     */
    Client.prototype.handleOldPacket = function (conn, ccc, data) {
        if (ccc in OldPacketHandler_1.default)
            OldPacketHandler_1.default[ccc].call(this, conn, ccc, data);
        this.emit("rawOldPacket", conn, ccc, data);
    };
    /**
     * Handles the known packets and emits events.
     */
    Client.prototype.handlePacket = function (conn, packet) {
        var ccc = packet.readUnsignedShort();
        if (ccc in PacketHandler_1.default)
            PacketHandler_1.default[ccc].call(this, conn, packet);
        this.emit("rawPacket", conn, ccc, packet);
    };
    /**
     * Handles the community platform packets and emits events.
     */
    Client.prototype.handleTribulle = function (code, packet) {
        if (code in TribullePacketHandler_1.default)
            TribullePacketHandler_1.default[code].call(this, packet);
        this.emit("rawTribulle", code, packet);
    };
    /**
     * Sends a packet to the community platform (tribulle).
     */
    Client.prototype.sendTribullePacket = function (code, packet) {
        this.tribulleId = (this.tribulleId % 0x100000000) + 1;
        var p = new utils_1.ByteArray().writeShort(code).writeUnsignedInt(this.tribulleId);
        p.writeBytes(packet);
        this.main.send(enums_1.identifiers.bulle, p, enums_1.cipherMethods.xor);
        return this.tribulleId;
    };
    /**
     * Sends a packet every 15 seconds to stay connected to the game.
     */
    Client.prototype.startHeartbeat = function () {
        var _this = this;
        this.main.send(enums_1.identifiers.heartbeat, new utils_1.ByteArray());
        this.loops.heartbeat = setInterval(function () {
            _this.main.send(enums_1.identifiers.heartbeat, new utils_1.ByteArray());
            if (_this.bulle && _this.bulle.open)
                _this.bulle.send(enums_1.identifiers.heartbeat, new utils_1.ByteArray());
        }, 1000 * 15);
    };
    Client.prototype.sendHandshake = function (version, key) {
        var p = new utils_1.ByteArray();
        p.writeShort(version);
        p.writeUTF("en");
        p.writeUTF(key);
        p.writeUTF("Desktop").writeUTF("-").writeInt(0x1fbd);
        p.writeUTF("");
        p.writeUTF("ca26ba3ada3fc0aadba7d94e5677bee000333d8f46bab4c3cb32e615587e7212");
        p.writeUTF("A=t&SA=t&SV=t&EV=t&MP3=t&AE=t&VE=t&ACC=t&PR=t&SP=f&SB=f&DEB=f&V=LNX 29,0,0,140&M=Adobe Linux&R=1920x1080&COL=color&AR=1.0&OS=Linux&ARCH=x86&L=en&IME=t&PR32=t&PR64=t&LS=en-US&PT=Desktop&AVD=f&LFD=f&WD=f&TLS=t&ML=5.1&DP=72");
        p.writeInt(0).writeInt(0x1234).writeUTF("");
        this.main.send(enums_1.identifiers.handshake, p);
    };
    Client.prototype.setLanguage = function (code) {
        if (code === void 0) { code = enums_1.languages.en; }
        if (typeof code !== "string")
            code = enums_1.languages.en;
        var p = new utils_1.ByteArray().writeUTF(code);
        this.main.send(enums_1.identifiers.language, p);
    };
    Client.prototype.setSystemInfo = function (langue, sys, version) {
        var p = new utils_1.ByteArray().writeUTF(langue).writeUTF(sys).writeUTF(version);
        this.main.send(enums_1.identifiers.os, p);
    };
    /**
     * Get Transformice API keys
     */
    Client.prototype.fetchKeys = function () {
        return __awaiter(this, void 0, void 0, function () {
            var response, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, node_fetch_1.default("https://api.tocuto.tk/get_transformice_keys.php?tfmid=" + this.tfmId + "&token=" + this.token)];
                    case 1:
                        response = _a.sent();
                        return [4 /*yield*/, response.json()];
                    case 2:
                        result = _a.sent();
                        if (result.success) {
                            if (!result.internal_error) {
                                this.version = result.version;
                                this.connectionKey = result.connection_key;
                                this.ports = result.ports;
                                this.host = result.ip;
                                this.authClient = result.auth_key;
                                this.identificationKeys = result.identification_keys;
                                this.messageKeys = result.msg_keys;
                            }
                            else {
                                if (result.internal_error_step === 2)
                                    throw new Error("The game might be in maintenance mode.");
                                throw new Error("An internal error occur: " + result.internal_error_step);
                            }
                        }
                        else {
                            throw new Error("Can't get the keys : " + result.error);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Log in to the game.
     */
    Client.prototype.login = function (name, password, room) {
        if (room === void 0) { room = "1"; }
        var p = new utils_1.ByteArray().writeUTF(name).writeUTF(utils_1.SHAKikoo(password));
        p.writeUTF("app:/TransformiceAIR.swf/[[DYNAMIC]]/2/[[DYNAMIC]]/4").writeUTF(room);
        p.writeUnsignedInt(parseInt((BigInt(this.authServer) ^ BigInt(this.authClient)).toString()));
        this.main.send(enums_1.identifiers.loginSend, p, enums_1.cipherMethods.xxtea);
    };
    /**
     * Connects and do handshake
     */
    Client.prototype.connect = function () {
        var _this = this;
        if (this.main && this.main.open)
            return;
        this.main = new utils_1.Connection(this.identificationKeys, this.messageKeys);
        this.main.on("data", function (conn, packet) {
            _this.handlePacket(conn, packet);
        });
        this.main.once("connect", function () { return __awaiter(_this, void 0, void 0, function () {
            var err_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.emit("connect", this.main);
                        this.sendHandshake(this.version, this.connectionKey);
                        this.once("loginError", function (code) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                if (code === 1 && this.autoReconnect) {
                                    this.restart();
                                }
                                return [2 /*return*/];
                            });
                        }); });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.waitFor("loginReady")];
                    case 2:
                        _a.sent();
                        this.login(this.name, this.password);
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        this.main.emit("error", err_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        this.main.once("close", function () {
            _this.disconnect();
        });
        this.main.on("error", function (err) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.emit("connectionError", err);
                        if (!this.autoReconnect) return [3 /*break*/, 2];
                        return [4 /*yield*/, new Promise(function (r) { return setTimeout(r, 5 * 1000); })];
                    case 1:
                        _a.sent();
                        this.restart();
                        return [3 /*break*/, 3];
                    case 2: throw Error("Connection Closed");
                    case 3: return [2 /*return*/];
                }
            });
        }); });
        this.main.connect(this.host, this.ports[0]);
    };
    /**
     * Disconnects the client.
     */
    Client.prototype.disconnect = function () {
        clearInterval(this.loops.heartbeat);
        if (this.main) {
            this.main.close();
            this.main.removeAllListeners();
        }
        if (this.bulle) {
            this.bulle.close();
            this.bulle.removeAllListeners();
        }
        this.emit("disconnect");
    };
    /**
     * Starts the client.
     */
    Client.prototype.run = function (tfmid, token) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.tfmId = tfmid;
                        this.token = token;
                        return [4 /*yield*/, this.fetchKeys()];
                    case 1:
                        _a.sent();
                        this.connect();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Restart the client
     */
    Client.prototype.restart = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.emit("restart");
                this.disconnect();
                this.connect();
                return [2 /*return*/];
            });
        });
    };
    /**
     * Sends a message to tribe
     */
    Client.prototype.sendTribeMessage = function (message) {
        this.sendTribullePacket(enums_1.tribulle.tribeSendMessage, new utils_1.ByteArray().writeUTF(message));
    };
    /**
     * Joins the tribe house.
     */
    Client.prototype.enterTribeHouse = function () {
        this.main.send(enums_1.identifiers.enterTribeHouse, new utils_1.ByteArray());
    };
    /**
     * Load a lua script in the room.
     */
    Client.prototype.loadLua = function (script) {
        var length = Buffer.byteLength(script);
        var p = new utils_1.ByteArray().writeUnsignedShort(length >> 8).writeUnsignedByte(length & 255);
        this.bulle.send(enums_1.identifiers.loadLua, p);
    };
    /**
     * Join to a chat channel
     */
    Client.prototype.joinChannel = function (channelName, permanent) {
        if (permanent === void 0) { permanent = true; }
        this.sendTribullePacket(enums_1.tribulle.channelJoinRequest, new utils_1.ByteArray().writeUTF(channelName).writeBoolean(permanent));
    };
    /**
     * Leave a chat channel
     */
    Client.prototype.leaveChannel = function (channelName) {
        this.sendTribullePacket(enums_1.tribulle.channelLeaveRequest, new utils_1.ByteArray().writeUTF(channelName));
    };
    /**
     * Request /who to a chat channel
     */
    Client.prototype.requestWho = function (channelName) {
        var fingerprint = this.sendTribullePacket(enums_1.tribulle.channelWhoRequest, new utils_1.ByteArray().writeUTF(channelName));
        this.whoList[fingerprint] = channelName;
        return fingerprint;
    };
    /**
     * Get player list inside a chat channel
     */
    Client.prototype.getChannelPlayers = function (channelName) {
        return __awaiter(this, void 0, void 0, function () {
            var fingerPrint;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fingerPrint = this.requestWho(channelName);
                        return [4 /*yield*/, this.waitFor("channelWho", function (n, p, f) { return f === fingerPrint; })];
                    case 1: return [2 /*return*/, (_a.sent())[1]];
                }
            });
        });
    };
    /**
     * Sends a message to a chat channel
     */
    Client.prototype.sendChannelMessage = function (channelName, message) {
        this.sendTribullePacket(enums_1.tribulle.channelSendMessage, new utils_1.ByteArray().writeUTF(channelName).writeUTF(message));
    };
    /**
     * Sends a message to the client's room.
     */
    Client.prototype.sendRoomMessage = function (message) {
        this.bulle.send(enums_1.identifiers.roomMessage, new utils_1.ByteArray().writeUTF(message), enums_1.cipherMethods.xor);
    };
    /**
     * Sends a server command.
     *
     * @param message - The command message (without the `/`).
     * @example
     * ```js
     * client.sendCommand('mod');
     * ```
     */
    Client.prototype.sendCommand = function (message) {
        this.main.send(enums_1.identifiers.command, new utils_1.ByteArray().writeUTF(message), enums_1.cipherMethods.xor);
    };
    /**
     * Sends a request to the server to join a room with specific name.
     */
    Client.prototype.enterRoom = function (name, options) {
        var _a;
        options = __assign({ auto: false, password: undefined }, options);
        this.main.send(enums_1.identifiers.room, new utils_1.ByteArray()
            .writeUTF("")
            .writeUTF(name)
            .writeBoolean((_a = options.auto) !== null && _a !== void 0 ? _a : false));
    };
    /**
     * Sends a whisper message to a player.
     */
    Client.prototype.sendWhisper = function (name, message) {
        this.sendTribullePacket(enums_1.tribulle.whisperSend, new utils_1.ByteArray().writeUTF(name.toLowerCase()).writeUTF(message));
    };
    /**
     * Request friend list.
     */
    Client.prototype.requestFriendList = function () {
        this.sendTribullePacket(28, new utils_1.ByteArray());
    };
    /**
     * Get friend list
     */
    Client.prototype.getFriendList = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.requestFriendList();
                        return [4 /*yield*/, this.waitFor("friendList")];
                    case 1: return [2 /*return*/, (_a.sent())[0]];
                }
            });
        });
    };
    /**
     * Add a player to friend list
     */
    Client.prototype.addFriend = function (name) {
        this.sendTribullePacket(enums_1.tribulle.friendAddRequest, new utils_1.ByteArray().writeUTF(name));
    };
    /**
     * Add a player to friend list
     */
    Client.prototype.removeFriend = function (name) {
        this.sendTribullePacket(enums_1.tribulle.friendRemoveRequest, new utils_1.ByteArray().writeUTF(name));
    };
    /**
     * Request tribe data
     */
    Client.prototype.requestTribe = function (includeDisconnectedMember) {
        if (includeDisconnectedMember === void 0) { includeDisconnectedMember = true; }
        this.sendTribullePacket(enums_1.tribulle.tribeRequest, new utils_1.ByteArray().writeBoolean(includeDisconnectedMember));
    };
    /**
     * Get tribe data
     */
    Client.prototype.getTribe = function (includeDisconnectedMember) {
        if (includeDisconnectedMember === void 0) { includeDisconnectedMember = true; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.requestTribe(includeDisconnectedMember);
                        return [4 /*yield*/, this.waitFor("tribe")];
                    case 1: return [2 /*return*/, (_a.sent())[0]];
                }
            });
        });
    };
    /**
     * Request profile
     *
     * Alias for: `client.sendCommand("profile")`
     */
    Client.prototype.requestProfile = function (username) {
        this.sendCommand("profile " + username);
    };
    /**
     * Get user profile
     */
    Client.prototype.getProfile = function (username) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.requestProfile(username);
                        return [4 /*yield*/, this.waitFor("profile")];
                    case 1: return [2 /*return*/, (_a.sent())[0]];
                }
            });
        });
    };
    return Client;
}(events_1.EventEmitter));
exports.default = Client;
