"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var enums_1 = require("../enums");
var structures_1 = require("../structures");
var utils_1 = require("../utils");
/**
 * @hidden
 */
var PacketHandler = /** @class */ (function () {
    function PacketHandler() {
    }
    /* -------------------------------------------------------------------------- */
    /*                                   General                                  */
    /* -------------------------------------------------------------------------- */
    PacketHandler[enums_1.identifiers.oldPacket] = function (conn, packet) {
        var data = packet.readUTF().split(String.fromCharCode(1));
        var a = data.splice(0, 1)[0];
        var ccc = (a.charCodeAt(0) << 8) | a.charCodeAt(1);
        this.handleOldPacket(conn, ccc, data);
    };
    PacketHandler[enums_1.identifiers.handshakeOk] = function (_conn, packet) {
        this.onlinePlayers = packet.readUnsignedInt();
        packet.readUTF(); // default language
        packet.readUTF(); // country;
        this.authServer = packet.readUnsignedInt();
        this.setLanguage(this.language);
        this.setSystemInfo("en", "Linux", "LNX 29,0,0,140");
        this.startHeartbeat();
    };
    PacketHandler[enums_1.identifiers.loginReady] = function () {
        this.emit("loginReady");
    };
    PacketHandler[enums_1.identifiers.fingerprint] = function (conn, packet) {
        conn.fingerprint = packet.readByte();
    };
    PacketHandler[enums_1.identifiers.bulle] = function (_conn, packet) {
        var code = packet.readUnsignedShort();
        this.handleTribulle(code, packet);
    };
    PacketHandler[enums_1.identifiers.bulleConnection] = function (_conn, packet) {
        var _this = this;
        var timestamp = packet.readUnsignedInt();
        var playerId = packet.readUnsignedInt();
        var pcode = packet.readUnsignedInt();
        var host = packet.readUTF();
        packet
            .readUTF()
            .split("-")
            .map(function (port) { return ~~port; }); // port
        if (this.bulle && this.bulle.open)
            this.bulle.close();
        this.bulle = new utils_1.Connection(this.identificationKeys, this.messageKeys);
        this.bulle.on("error", function (err) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.emit("connectionError", err);
                        if (!this.autoReconnect) return [3 /*break*/, 2];
                        return [4 /*yield*/, new Promise(function (r) { return setTimeout(r, 5 * 1000); })];
                    case 1:
                        _a.sent();
                        this.restart();
                        return [3 /*break*/, 3];
                    case 2: throw Error("Connection Closed");
                    case 3: return [2 /*return*/];
                }
            });
        }); });
        this.bulle.on("data", function (conn, packet) {
            _this.handlePacket(conn, packet);
        });
        this.bulle.on("connect", function () {
            _this.bulle.send(enums_1.identifiers.bulleConnection, new utils_1.ByteArray()
                .writeUnsignedInt(timestamp)
                .writeUnsignedInt(playerId)
                .writeUnsignedInt(pcode));
        });
        this.bulle.connect(host, this.ports[0]);
    };
    PacketHandler[enums_1.identifiers.profile] = function (_conn, packet) {
        this.emit("profile", new structures_1.Profile(this).read(packet));
    };
    /* -------------------------------------------------------------------------- */
    /*                                Login Result                                */
    /* -------------------------------------------------------------------------- */
    PacketHandler[enums_1.identifiers.loggedIn] = function (_conn, packet) {
        this.playerId = packet.readUnsignedInt();
        this.name = packet.readUTF();
        this.playingTime = packet.readUnsignedInt();
        this.connectionTime = new Date().getTime();
        this.community = packet.readByte();
        this.pcode = packet.readUnsignedInt();
        this.emit("login", this.name, this.pcode);
    };
    PacketHandler[enums_1.identifiers.loginError] = function (_conn, packet) {
        this.emit("loginError", packet.readUnsignedByte(), packet.readUTF(), packet.readUTF());
    };
    /* -------------------------------------------------------------------------- */
    /*                                    Room                                    */
    /* -------------------------------------------------------------------------- */
    PacketHandler[enums_1.identifiers.luaChatLog] = function (_conn, packet) {
        this.emit("luaLog", packet.readUTF());
    };
    PacketHandler[enums_1.identifiers.roomMessage] = function (_conn, packet) {
        var player = this.room.getPlayer(packet.readUTF());
        if (!player)
            return;
        var content = packet.readUTF();
        var message = new structures_1.RoomMessage(this, player, content);
        this.emit("roomMessage", message);
    };
    PacketHandler[enums_1.identifiers.roomChange] = function (_conn, packet) {
        var before = this.room;
        var isPublic = packet.readBoolean();
        var name = packet.readUTF();
        var language = packet.readUTF();
        this.room = new structures_1.Room(this, isPublic, name, language);
        this.emit("roomChange", this.room, before);
    };
    PacketHandler[enums_1.identifiers.roomPlayerList] = function (_conn, packet) {
        var before = this.room.playerList;
        this.room.playerList = [];
        var length = packet.readUnsignedShort();
        for (var i = 0; i < length; i++) {
            var player = new structures_1.RoomPlayer(this).read(packet);
            this.room.playerList.push(player);
        }
        this.player = this.room.getPlayer(this.pcode);
        this.emit("roomPlayersUpdate", this.room.playerList, before);
    };
    PacketHandler[enums_1.identifiers.roomPlayerEnter] = function (_conn, packet) {
        var player = new structures_1.RoomPlayer(this).read(packet);
        if (this.room.getPlayer(player.pcode)) {
            this.room.updatePlayer(player);
            this.emit("roomPlayerUpdate", player, this.room.getPlayer(player.pcode));
        }
        else {
            this.room.addPlayer(player);
            this.emit("roomPlayerEnter", player);
        }
    };
    PacketHandler[enums_1.identifiers.roomPlayerWin] = function (_conn, packet) {
        packet.readByte();
        var player = this.room.getPlayer(packet.readInt());
        if (player) {
            player.score = packet.readShort();
            var order = packet.readByte();
            var time = packet.readShort() / 100;
            this.emit("roomPlayerEnterHole", player, order, time);
        }
    };
    PacketHandler[enums_1.identifiers.roomPlayerGetCheese] = function (_conn, packet) {
        var player = this.room.getPlayer(packet.readInt());
        if (player) {
            player.hasCheese = packet.readBoolean();
            this.emit("roomPlayerGetCheese", player);
        }
    };
    return PacketHandler;
}());
exports.default = PacketHandler;
