import Client from "../client";
import Base from "./Base";
/** Represents a player from the room. */
export default class Player extends Base {
    /**
     * The player's name.
     */
    name: string;
    /**
     * @hidden
     */
    constructor(client: Client, name?: string);
    /**
     * Send a whisper to the player
     */
    whisper(message: string): void;
    /**
     * Add player to the friend list
     */
    friend(): void;
    /**
     * Remove player from the friend list
     */
    unfriend(): void;
}
