import { ValueOf, ByteArray } from "../utils";
import { genders } from "../enums";
import Client from "../client";
import { Player } from ".";
/** Represents player's profile from `/profile` command */
export default class Profile extends Player {
    id: number;
    gender: ValueOf<typeof genders>;
    registrationDate: number;
    role: number;
    tribeName: string;
    soulmate: string;
    saves: {
        normal: number;
        hard: number;
        divine: number;
    };
    shamanCheese: number;
    first: number;
    cheese: number;
    bootcamp: number;
    titleId: number;
    titles: {
        id: number;
        star: number;
    }[];
    look: string;
    level: number;
    badges: {
        id: number;
        quantity: number;
    }[];
    modeStatus: {
        mode: number;
        progress: number;
        progressLimit: number;
        imageId: number;
    }[];
    orbId: number;
    orbs: number[];
    adventurePoints: number;
    /**
     * @hidden
     */
    constructor(client: Client, player?: Partial<Profile>);
    /**
     * Returns member data from a packet
     *
     * @hidden
     */
    read(packet: ByteArray): this;
}
