"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Player_1 = __importDefault(require("./Player"));
/** Represents a player from the room. */
var RoomPlayer = /** @class */ (function (_super) {
    __extends(RoomPlayer, _super);
    /**
     * @hidden
     */
    function RoomPlayer(client) {
        var _this = _super.call(this, client) || this;
        _this.gender = 0;
        _this.look = "";
        _this.pcode = 0;
        _this.title = 0;
        _this.titleStars = 0;
        _this.hasCheese = false;
        _this.isDead = false;
        _this.isShaman = false;
        _this.isVampire = false;
        _this.score = 0;
        _this.mouseColor = 0;
        _this.nameColor = -1;
        _this.shamanColor = 0;
        _this.facingRight = true;
        _this.movingLeft = false;
        _this.movingRight = false;
        _this.x = 0;
        _this.y = 0;
        _this.vx = 0;
        _this.vy = 0;
        _this.isJumping = false;
        return _this;
    }
    /**
     * Reads player data from a packet.
     *
     * @hidden
     */
    RoomPlayer.prototype.read = function (packet) {
        this.name = packet.readUTF();
        this.pcode = packet.readUnsignedInt();
        this.isShaman = packet.readBoolean();
        this.isDead = packet.readBoolean();
        this.score = packet.readUnsignedShort();
        this.hasCheese = packet.readBoolean();
        this.title = packet.readUnsignedShort();
        this.titleStars = packet.readByte() - 1;
        this.gender = packet.readByte();
        packet.readUTF(); // Unknown string
        this.look = packet.readUTF();
        packet.readBoolean(); // Unknown boolean
        this.mouseColor = packet.readUnsignedInt();
        this.shamanColor = packet.readUnsignedInt();
        packet.readUnsignedInt(); // Unknown int
        var color = packet.readUnsignedInt();
        this.nameColor = color === 0xffffffff ? -1 : color;
        return this;
    };
    return RoomPlayer;
}(Player_1.default));
exports.default = RoomPlayer;
